=== modified file 'src/com/goldencode/p2j/persist/TempTableBuilder.java'
--- src/com/goldencode/p2j/persist/TempTableBuilder.java	2022-11-08 19:25:33 +0000
+++ src/com/goldencode/p2j/persist/TempTableBuilder.java	2022-11-11 12:09:01 +0000
@@ -122,7 +122,11 @@
 **     OM  20220914 Added MAX-WIDTH support for CHARACTER fields.
 **     IAS 20221003 Fixed default value of the PRIMARY attribute
 **     IAS 20221014 Added COMHANDLE to the 'datatypesMatchLen' map
+**     IAS 20221029 Added support for missed properties.
+**     IAS 20221104 Added indexes parsing for input remote table.
+**     IAS 20221108 Replaced static 'createRemoteTable' with a regular one.
 **     CA  20221108 BEFORE-TABLE's name is always trimmed to max 32 chars length.
+**     IAS 20221111 Fixed 'schemaMarshalLevel' support.
 */
 
 /*
@@ -314,55 +318,46 @@
     *           The XML namespace.
     * @param    xmlPrefix
     *           The XML prefix.
+    * @param    schemaMarshalLevel
+    *           The SCHEMA-MARSHAL level for the serialized temp-table. 
+    * @return   default buffer for the table
     */
-   public static BufferImpl createRemoteTable(String tableName,
+   public BufferImpl createRemoteTable(String tableName,
                                               Iterator<PropertyDefinition> props,
                                               String tableIndexes, 
                                               String xmlns,
-                                              String xmlPrefix)
-   {
-      TempTableBuilder ttb = new TempTableBuilder();
-      props.forEachRemaining(ttb::addNewField);
-      
-      if (tableIndexes != null)
-      {
-         String[] indexes = tableIndexes.split("\\.");
-         for (int i = 0; i < indexes.length; i++)
-         {
-            String indexDef = indexes[i];
-            if (indexDef.isEmpty())
-            {
-               continue;
-            }
-            String[] compAndName = indexDef.split(":");
-            String typeAndComps = compAndName[0];
-            String idxName = compAndName[1];
-            String[] comps = typeAndComps.split(",");
-            boolean unique = (i != 0) || "1".equals(comps[0]);
-            boolean primary = (i == 0) && ("1".equals(comps[0]) || "0".equals(comps[0]));
-            
-            ttb.addNewIndex(new character(idxName),
-                            new logical(unique),
-                            new logical(primary));
-            for (int j = (primary ? 1 : 0); j < comps.length; j++)
-            {
-               ttb.addFieldToIndex(idxName, comps[j]);
-            }
-         }
-      }
-      
-      ttb.tempTablePrepare(tableName);
-      BufferImpl buff = (BufferImpl) ttb.defaultBufferHandle().getResource();
-      if (xmlns != null)
-      {
-         buff.namespaceURI(xmlns);
-      }
-      if (xmlPrefix != null)
-      {
-         buff.namespacePrefix(xmlPrefix);
-      }
-      
-      return buff;
+                                              String xmlPrefix,
+                                              int schemaMarshalLevel)
+   {
+      return createTable(tableName, props, 
+               () -> parseIndexString(tableIndexes), xmlns, xmlPrefix, schemaMarshalLevel);
+   }
+   
+   /**
+    * Create a temp-table with the specified definition, as received from a remote side.
+    * 
+    * @param    tableName
+    *           The table name.
+    * @param    props
+    *           The property definitions.
+    * @param    indexProvider
+    *           indexes' provider.
+    * @param    xmlns
+    *           The XML namespace.
+    * @param    xmlPrefix
+    *           The XML prefix.
+    * @param    schemaMarshalLevel
+    *           The SCHEMA-MARSHAL level for the serialized temp-table.      
+    * @return   default buffer for the table
+    */
+   public BufferImpl createRemoteTable(String tableName,
+                                              Iterator<PropertyDefinition> props,
+                                              Runnable indexProvider, 
+                                              String xmlns,
+                                              String xmlPrefix,
+                                              int schemaMarshalLevel)
+   {
+      return createTable(tableName, props, indexProvider, xmlns, xmlPrefix, schemaMarshalLevel);
    }
    
    /**
@@ -1341,6 +1336,60 @@
                               character    label,
                               character    columnLabel)
    {
+      return addNewField(name, type, extent, format, initial, label, columnLabel,
+               null, null, null, false, false);
+   }
+   /**
+    * Adds a field with the specified properties to the temp-table.
+    * This method is the P2J equivalent of <code>ADD-NEW-FIELD</code> method
+    * of Progress 4GL.
+    * <p>
+    * When a parameter is set to null, it means it was not specified by the business logic.
+    *
+    * @param   name
+    *          The name of the field to be created in the temp-table.
+    * @param   type
+    *          The data type of the specified field.
+    * @param   extent
+    *          An integer expression specifying the extent of an array.
+    * @param   format
+    *          The data format for the defined data type. If empty or unknown, format is
+    *          replaced with default format. Null value means that format is not used in
+    *          ADD-NEW-FIELD.
+    * @param   initial
+    *          An expression that evaluates to the initial value of the defined field.
+    *          TODO: this method will probably be overloaded because of this.
+    * @param   label
+    *          The label of the defined field. If <code>null</code> or unknown the name
+    *          parameter will be used.
+    * @param   columnLabel
+    *          The label of the column associated with the defined field
+    * @param   help 
+    *          Field HELP attribute value.
+    * @param   xmlNodeType
+    *          Field XML node type. 
+    * @param   codePage 
+    *          Field code page. 
+    * @param   serializeHidden
+    *          Field SERIALIZE-HIDDEN attribute value.
+    * @param   caseSensitive 
+    *          Field CASE-SENSITIVE attribute value.
+    *
+    * @return  <code>true</code> on success.
+    */
+   public logical addNewField(character    name,
+                              character    type,
+                              integer      extent,
+                              character    format,
+                              BaseDataType initial,
+                              character    label,
+                              character    columnLabel,
+                              character    help,
+                              character    xmlNodeType,
+                              character    codePage,
+                              boolean      serializeHidden,
+                              boolean      caseSensitive)
+   {
       addFunctionCalled = true;
       
       if (_prepared())
@@ -1398,12 +1447,16 @@
       
       String labelStr = label != null ? label.getValue() : null;
       String columnLabelStr = columnLabel != null ? columnLabel.getValue() : null;
+      String helpStr = help != null ? help.getValue() : null;
+      String codePageStr = codePage != null ? codePage.getValue() : null;
+      String xmlNodeTypeStr = xmlNodeType != null ? xmlNodeType.getValue() : null;
       
       // Note: case-sensitivity and CLOB code page cannot be specified using P4GL ADD-NEW-FIELD method
       long ext = extent == null || extent.getValue() == 1 ? 0 : extent.getValue();
       P2JField field = new P2JField(fieldName, parmType, ext, formatStr,
-                                    initial, labelStr, columnLabelStr, false, null, null, false, null, null,
-                                    null, null, false, 0, 0);
+                                    initial, labelStr, columnLabelStr, caseSensitive, 
+                                    codePageStr, helpStr, serializeHidden, null, null,
+                                    null, xmlNodeTypeStr, false, 0, 0);
       addField(field);
       return new logical(true);
    }
@@ -2733,6 +2786,78 @@
    }
    
    /**
+    * Create a temp-table with the specified definition.
+    * 
+    * @param    tableName
+    *           The table name.
+    * @param    props
+    *           The property definitions.
+    * @param    tableIndexes
+    *           The index definitions.
+    * @param    xmlns
+    *           The XML namespace.
+    * @param    xmlPrefix
+    *           The XML prefix.
+    * @param    schemaMarshalLevel
+    *           The SCHEMA-MARSHAL level for the serialized temp-table. 
+    * @return   default buffer for the table
+    */
+   public BufferImpl createTable(String tableName,
+                                 Iterator<PropertyDefinition> props,
+                                 String tableIndexes, 
+                                 String xmlns,
+                                 String xmlPrefix,
+                                 int schemaMarshalLevel)
+   {
+      return  createTable(tableName, props, 
+                          () -> parseIndexString(tableIndexes), 
+                          xmlns, xmlPrefix, schemaMarshalLevel);
+   }
+
+   /**
+    * Create a temp-table with the specified definition.
+    * 
+    * @param    tableName
+    *           The table name.
+    * @param    props
+    *           The property definitions.
+    * @param    indexProvider
+    *           indexes' provider.
+    * @param    xmlns
+    *           The XML namespace.
+    * @param    xmlPrefix
+    *           The XML prefix.
+    * @param    schemaMarshalLevel
+    *           The SCHEMA-MARSHAL level for the serialized temp-table. 
+    * @return   default buffer for the table
+    */
+   public BufferImpl createTable(String tableName,
+                                 Iterator<PropertyDefinition> props,
+                                 Runnable indexProvider, 
+                                 String xmlns,
+                                 String xmlPrefix,
+                                 int schemaMarshalLevel)
+   {
+      setSchemaMarshalLevel(schemaMarshalLevel);
+      props.forEachRemaining(this::addNewField);
+      
+      indexProvider.run();
+      
+      tempTablePrepare(tableName);
+      BufferImpl buff = (BufferImpl) defaultBufferHandle.getResource();
+      if (xmlns != null)
+      {
+         buff.namespaceURI(xmlns);
+      }
+      if (xmlPrefix != null)
+      {
+         buff.namespacePrefix(xmlPrefix);
+      }
+      
+      return buff;
+   }
+
+   /**
     * Build temporary table from a table wrapper object.
     *
     * @param tableWrapper
@@ -2748,14 +2873,25 @@
       {
          return;
       }
-
-      Iterator<PropertyDefinition> iter = tableWrapper.propertyIterator();
-      while(iter.hasNext())
-      {
-         PropertyDefinition propertyDefinition = iter.next();
-         addNewField(propertyDefinition);
-      }
-      tempTablePrepare(tableWrapper.getTableName());
+      List<IndexDefinition> indexDefs = tableWrapper.getIndexDefs();
+      if (indexDefs != null)
+      {
+         createTable(tableWrapper.getTableName(), 
+                  tableWrapper.propertyIterator(), 
+                  () -> indexDefs.stream().forEach(idx -> idx.addTo(this)), 
+                  tableWrapper.getXmlns(), 
+                  tableWrapper.getXmlPrefix(),
+                  tableWrapper.getSchemaMarshalLevel());
+      }
+      else
+      {
+         createTable(tableWrapper.getTableName(), 
+                  tableWrapper.propertyIterator(), 
+                  tableWrapper.getIndexes(), 
+                  tableWrapper.getXmlns(), 
+                  tableWrapper.getXmlPrefix(),
+                  tableWrapper.getSchemaMarshalLevel());
+      }
       TemporaryBuffer.insertAllRows(tableWrapper,
                                     (Temporary) defaultBufferHandle().getResource(),
                                     true,
@@ -3120,9 +3256,14 @@
                   new character(dataType),
                   extent,
                   new character(propertyDefinition.getFormat()),
-                  null,
+                  new character(propertyDefinition.getInitial()),
                   new character(propertyDefinition.getLabel()),
-                  new character(propertyDefinition.getColumnLabel()));
+                  new character(propertyDefinition.getColumnLabel()),
+                  new character(propertyDefinition.getHelp()),
+                  new character(propertyDefinition.getXmlNodeType()),
+                  new character(propertyDefinition.getCodePage()),
+                  propertyDefinition.isSerializeHidden(),
+                  propertyDefinition.isCaseSensitive());
    }
    
    /**
@@ -3766,6 +3907,42 @@
    }
    
    /**
+    * Add indexes based on multiIxCols string.
+    * 
+    * @param tableIndexes
+    *        multiIxCols string to be parsed.
+    */
+   private void parseIndexString(String tableIndexes)
+   {
+      if (tableIndexes != null)
+      {
+         String[] indexes = tableIndexes.split("\\.");
+         for (int i = 0; i < indexes.length; i++)
+         {
+            String indexDef = indexes[i];
+            if (indexDef.isEmpty())
+            {
+               continue;
+            }
+            String[] compAndName = indexDef.split(":");
+            String typeAndComps = compAndName[0];
+            String idxName = compAndName[1];
+            String[] comps = typeAndComps.split(",");
+            boolean unique = (i != 0) || "1".equals(comps[0]);
+            boolean primary = (i == 0) && ("1".equals(comps[0]) || "0".equals(comps[0]));
+            
+            addNewIndex(new character(idxName),
+                            new logical(unique),
+                            new logical(primary));
+            for (int j = (primary ? 1 : 0); j < comps.length; j++)
+            {
+               addFieldToIndex(idxName, comps[j]);
+            }
+         }
+      }
+   }
+
+   /**
     * Returns a string representation of the object.
     *
     * @return string representation of the object.

=== modified file 'src/com/goldencode/p2j/persist/TempTableResultSet.java'
--- src/com/goldencode/p2j/persist/TempTableResultSet.java	2022-10-06 08:18:44 +0000
+++ src/com/goldencode/p2j/persist/TempTableResultSet.java	2022-11-04 08:12:06 +0000
@@ -31,6 +31,7 @@
 **     SVL 20210701 Added clearRows.
 **     CA  20221006 Do not access tableHandle() in the FWD runtime, get the TempTable instance directly.  
 **                  Refs #6826
+**     IAS 20221029 Re-worked 'init' method.
 */
 
 /*
@@ -189,11 +190,8 @@
     * @param    append
     *           Flag indicating this table is sent in APPEND mode.
     *           
-    * @throws   ClassNotFoundException
-    *           If the type of a property can not be resolved to a class.
     */
    public TempTableResultSet(Temporary dmo, boolean input, boolean output, boolean append)
-//   throws ClassNotFoundException
    {
       this(dmo, input, output, append, true);
    }
@@ -358,11 +356,8 @@
     * TODO: improve this (i.e. use an open cursor or some other alternative to not read the data
     *       in memory)
     * 
-    * @throws   ClassNotFoundException
-    *           If the type of a property can not be resolved to a class.
     */
    private void init(boolean copyRows)
-//   throws ClassNotFoundException
    {
       TemporaryBuffer buffer = (TemporaryBuffer) ((BufferReference) dmo).buffer();
       
@@ -387,45 +382,11 @@
       {
          dmoPropIndex.put(dmoProps[i], i);
       }
-      PropertyDefinition[] props = new PropertyDefinition[dmoProps.length];
       
       Iterator<Property> iter = dmoInfo.getFields(false); // skip properties that are not accessible via the DMO's API.
-      while (iter.hasNext())
-      {
-         Property prop = iter.next();
-         // the Properties whose extent fields were denormalized are treated as simple ones 
-         int extent = prop.index > 0 ? 0 : prop.extent;
-         if (extent == 0)
-         {
-            props[dmoPropIndex.get(prop.name)] = 
-               new PropertyDefinition(prop.name,
-                                      prop._fwdType,
-                                      prop.legacy,
-                                      prop.format,
-                                      prop.label,
-                                      prop.columnLabel);
-         }
-         else
-         {
-            props[dmoPropIndex.get(prop.name)] = 
-               new PropertyDefinition(prop.name,
-                                      prop._fwdType,
-                                      extent,
-                                      prop.legacy,
-                                      prop.format,
-                                      prop.label,
-                                      prop.columnLabel);
-         }
-      }
-      
-      java.util.List<PropertyDefinition> lprops = new ArrayList<>();
-      for (int i = 0; i < props.length; i++)
-      {
-         if (props[i] != null)
-         {
-            lprops.add(props[i]);
-         }
-      }
+      Map<Integer, PropertyDefinition> mprops = new TreeMap<>();
+      iter.forEachRemaining(prop -> mprops.put(dmoPropIndex.get(prop.name), new PropertyDefinition(prop)));
+      List<PropertyDefinition> lprops = new ArrayList<>(mprops.values());
 
       if (copyRows)
       {

=== modified file 'src/com/goldencode/p2j/persist/TemporaryBuffer.java'
--- src/com/goldencode/p2j/persist/TemporaryBuffer.java	2022-11-03 00:24:27 +0000
+++ src/com/goldencode/p2j/persist/TemporaryBuffer.java	2022-11-11 12:01:31 +0000
@@ -623,7 +623,9 @@
 **                           they are not.
 **     OM  20221027          Use Dialect API to create and drop sequences.
 **     CA  20221031          Added JMX instrumentation for TABLE[-HANDLE] parameter processing.
+**     IAS 20221102          Added error reporting for SCHEMA-MARSHAL == NONE.
 **     OM  20221103          New class names for FQLPreprocessor, FQLExpression, FQLBundle, and FQLCache.
+**     IAS 20221103          Fixed support for a binded table parameter.
 */
 
 /*
@@ -2209,6 +2211,16 @@
          return;
       }
       
+      if (src.isRemoteParameter()  && !src.getResultSet().isReceivedSchema())
+      {
+         RecordBuffer rb = ((BufferReference) dstDMO).buffer();
+         DmoMeta meta = rb.getDmoInfo();
+         Iterator<Property> props = meta.getFields(false);
+         List<PropertyDefinition> pdl = new ArrayList<>();
+         props.forEachRemaining(p -> pdl.add(new PropertyDefinition(p)));
+         src.getResultSet().setProperties(pdl);
+      }
+      
       boolean bind = src.isBind() || options.contains(ParameterOption.BIND);
       
       if (src.isByReference() || bind || (!src.isRemoteParameter() && buffer.referenceOnly))
@@ -2600,6 +2612,12 @@
          else
          {
             TableWrapper resultSet = src.getResultSet();
+            if (!resultSet.isReceivedSchema())
+            {
+               // A NO-SCHEMA-MARSHAL table cannot be used as a parameter where the receiving side
+               // does not have a pre-prepared schema
+               ErrorManager.recordOrThrowError(12323);
+            }
             if (resultSet != null && resultSet.isValid() && resultSet.getTableName() != null)
             {
                TempTableBuilder builder = new TempTableBuilder();

=== modified file 'src/com/goldencode/p2j/persist/orm/DmoMeta.java'
--- src/com/goldencode/p2j/persist/orm/DmoMeta.java	2022-09-17 01:08:47 +0000
+++ src/com/goldencode/p2j/persist/orm/DmoMeta.java	2022-10-18 08:44:59 +0000
@@ -39,6 +39,7 @@
 **                  to a better suited name.
 **     OM  20220706 The objects returned by getDatabaseIndexes() carry the legacy names, too.
 **     OM  20220914 Use MAX-WIDTH to generate custom sized varchar columns.
+**     IAS 20221018 Fixed processing of 'now' and 'today' INITIAL attribute value.
 */
 
 /*
@@ -1591,13 +1592,13 @@
                      {
                         if (bdtType == date.class)
                         {
-                           init = "today".equalsIgnoreCase(p.initial) ? date.today() : new date(p.initial);
+                           init = "today".equalsIgnoreCase(p.initial) ? new character(p.initial) : new date(p.initial);
                         }
                         else if (bdtType == datetime.class)
                         {
                            if ("now".equalsIgnoreCase(p.initial))
                            {
-                              init = datetime.now();
+                              init =  new character(p.initial);
                            }
                            else if (p.initial.toUpperCase().indexOf('T') > 0)
                            {
@@ -1614,7 +1615,7 @@
                         {
                            if ("now".equalsIgnoreCase(p.initial))
                            {
-                              init = datetimetz.now();
+                              init = new character(p.initial);
                            }
                            else if (p.initial.toUpperCase().indexOf('T') > 0)
                            {

=== modified file 'src/com/goldencode/p2j/persist/serial/TempTableSchema.java'
--- src/com/goldencode/p2j/persist/serial/TempTableSchema.java	2022-10-07 11:11:20 +0000
+++ src/com/goldencode/p2j/persist/serial/TempTableSchema.java	2022-11-11 09:19:05 +0000
@@ -27,7 +27,10 @@
 **                  state in MutableFieldInfo, for the actual TempTable instance. Refs #6825
 **     CA  20220520 Added support for TEXT and ATTRIBUTE XML-NODE-TYPE values.
 **     OM  20220525 Fixed case-sensitivity for column lookup.
-**     IAS 20221006 Added ' getCodePage()', 'getDefinedFormat()', and 'getDefinedLabel()' .
+**     IAS 20221006 Added 'getCodePage()', 'getDefinedFormat()', and 'getDefinedLabel()' .
+**     IAS 20221111 Added 'buffer', 'xmlNodeName', 'nsURI', and 'nsPrefix' fields. This is 
+**                  required for tables in the the DATASET parameters' support since they are 
+**                  processed differently from the standalone tables.
 */
 
 /*
@@ -99,12 +102,24 @@
  */
 public class TempTableSchema
 {
+   /* RecordBuffer on the temp-table */
+   private final RecordBuffer buffer;
+   
    /** Legacy name of the temp-table */
    private final String name;
    
    /** XML serialization name of the temp-table */
    private final String xmlName;
+ 
+   /** XML node name of the temp-table */
+   private final String xmlNodeName;
    
+   /** XML namespace URI of the temp-table */
+   private final String nsURI;
+
+   /** XML prefix of the temp-table */
+   private final String nsPrefix;
+
    /** Schema information needed for serialization of all columns/fields, in the DMO order. */
    private final List<Column> columnList = new ArrayList<>();
    
@@ -142,6 +157,7 @@
       BufferImpl buf = (BufferImpl) recBuf.getDMOProxy();
       
       // the table name is used for serialization, regardless of the individual buffer name
+      this.buffer = recBuf;
       this.name = TableMapper.getLegacyName(recBuf);
       this.xmlName = buf.getSerializeName().toJavaType();
       
@@ -150,6 +166,10 @@
       Map<String, Method> setterMap = PropertyHelper.allSettersByProperty(dmoIface);
       
       TempTable tt = recBuf.getParentTable();
+      this.xmlNodeName = tt.getXmlNodeName().toJavaType();
+      this.nsURI = tt.namespaceURI().isUnknown() ? "" : tt.namespaceURI().toJavaType();
+      this.nsPrefix = tt.namespacePrefix().toJavaType();
+      
       List<TableMapper.LegacyFieldInfo> fields = TableMapper.getAllLegacyFieldInfo(tt);
       Iterator<TableMapper.LegacyFieldInfo> iter = fields.iterator();
       this.noUndo = !tt.canUndo().toJavaType();
@@ -238,6 +258,46 @@
    }
    
    /**
+    * Get the RecordBuffer on the temp-table.
+    * 
+    * @return RecordBuffer on the temp-table.
+    */
+   public RecordBuffer buffer()
+   {
+      return buffer;
+   }
+
+   /**
+    * Get the XML node name of the temp-table.
+    * 
+    * @return XML node name of the temp-table.
+    */
+   public String xmlNodeName()
+   {
+      return xmlNodeName;
+   }
+
+   /**
+    * Get the XML namespace URI of the temp-table.
+    * 
+    * @return XML namespace URI of the temp-table.
+    */
+   public String namespaceURI()
+   {
+      return nsURI;
+   }
+
+   /**
+    * Get the XML prefix of the temp-table.
+    * 
+    * @return  XML prefix of the temp-table.
+    */
+   public String namespacePrefix()
+   {
+      return nsPrefix;
+   }
+   
+   /**
     * Get the legacy name of this temp-table.
     * 
     * @return  Legacy table name.

